#ifndef EXPLORER_H
#define EXPLORER_H
#include <vector>
#include "Utilities.h"
#include "Input.h"
#include "Control.h"
#include "Random.h"
#include "Solution.h"
#include "SolutionManager.h"

using namespace std;

class NeighborhoodExplorer
{
 public:       
    NeighborhoodExplorer(SolutionManager* sm,  Random *rnd, Graph* pin = NULL) 
      {p_sm = sm; p_in = pin; rg = rnd;}
    NeighborhoodExplorer(const NeighborhoodExplorer* ne)
    { p_sm = ne->p_sm; p_in = ne->p_in; rg = ne->rg;}
    /** Virtual destructor. */
    virtual ~NeighborhoodExplorer() {};

    virtual void MakeMove(Coloring&, const Move&) {};
    virtual void NextMove(const Coloring&, Move&, long unsigned current_iter) {};
    virtual void BestMove(const Coloring &st, Move& mv) {};
  protected:
    SolutionManager* p_sm; /**< A pointer to the attached 
					state manager. */
    Graph* p_in; /**< A pointer to the input object. */
    Random *rg;
};


#endif





