#ifndef INPUT_H
#define INPUT_H

#include<cstdlib>
#include <vector>
#include <map>
#include <iostream>
#include <string>
#include "Utilities.h" 

using namespace std;

// Input class

class Graph
  {
    friend std::ostream& operator<<(std::ostream&, const Graph&);
  public:
    Graph();
    /* this method loads a DIMACS coded graph coloring instance */
    void Load(const char *id, bool print_statistics);  
    unsigned int Vertices() const  { return num_of_vertices; }
    unsigned int Edges() const  { return num_of_edges; }
    virtual ~Graph();
    bool Edge(const Vertex& v, const Vertex& w) const
      { return adjacency_matrix[v][w] != 0; }
    float Density() const {return density;}
    float AvDegree() const {return av_degree;}
    
    vector< VertexSet > adjacency_set;
    vector<unsigned int> degree;
  protected:
    unsigned int num_of_vertices;
    unsigned int num_of_edges;
    unsigned int max_degree;
    unsigned int min_degree;

    float density;
    float av_degree;
    unsigned char **adjacency_matrix;       

 };


#endif


