#include <algorithm>
#include <cmath>

#include <iostream>
#include <fstream>
#include "Solution.h"


std::ostream& operator<<(std::ostream& os, const Coloring& coloring)
{
  const Graph& g = *coloring.p_in; // g is an alias for the input Graph
  
  if (false)
    {
      int viol = 0;
      // write the coloring
      for (Vertex v = 0; v < g.Vertices(); v++)
	{
	  os << v << "[" << coloring.col[v] << "], ";
	  for (Vertex w = v + 1; w < g.Vertices(); w++)
	    if (g.Edge(v,w) && coloring.col[v] == coloring.col[w])
	      viol++;
	}
      
      os << endl <<" Colors: " << coloring.k
	 << " Conflicting edges: " << viol
	 << " Fitness: "<< coloring.fitness<< endl;
      //copy(coloring.conflicts.begin(), coloring.conflicts.end(), 
      //ostream_iterator<Vertex>(os, " "));
      //copy(coloring.adj_x_color.begin(), coloring.adj_x_color.end(), ostream_iterator<Vertex>(os, " "));
    }
  else
    for (Vertex v = 0; v < g.Vertices(); v++)
      {
	os<<coloring.col[v]+1<<endl;
      }
  return os;
}


Coloring::Coloring(Random* rnd, Graph* pin) 
{
  rg = rnd;
  // initialize the delta map
  p_in = pin;
  col.resize(pin->Vertices()); 
  k = INT_MAX;
  feasible = false;
}


Coloring& Coloring::operator=(const Coloring &a)
{
  if (this == &a) return *this;
  /* if (this == NULL)
     {
     try {
     this = new Coloring(a.rg, a.p_in)
     } catch (bad alloc xa)
     {
     cerr<<"Bad alloc in copy constructor Solution"<<endl;
     }
     }*/
  p_in = a.p_in;
  rg = a.rg;
  
  k = a.k;
  fitness = a.fitness;
  feasible = a.feasible;
  col = a.col;
  return *this;
}


Coloring::Coloring(const Coloring &a)
{
  p_in = a.p_in;
  rg = a.rg;
  
  k = a.k;
  fitness = a.fitness;
  col = a.col;
  feasible = a.feasible;
}


bool Coloring::operator==(const Coloring &a)
{
  
  if (p_in != a.p_in)
    {
      cerr << "input data!"<<endl;
      return false;
    }
  if (rg != a.rg)
    { 
      cerr << "random data!"<<endl;
      return false;
    }
  
  if (k != a.k)
    {
      cerr << "k!"<<endl;
      return false;
    }
 
  if (fitness != a.fitness)
    {
      cerr << "fitness data!"<<endl;
      cerr << fitness << " " << a.fitness<< endl;
      return false;
    }
 
  if (feasible != a.feasible)
    {
      cerr << "feasible data!";
      return false;
    }
 
  if (col != a.col)
    {
      cerr << "col data!"<<endl;
      return false;
    }
  return true;
}



void Coloring::SetInput(Graph* pin) 
{
  p_in = pin; 
  col.resize(pin->Vertices()); 
}

void Coloring::SetColors(Color num_col)
{
  this->k = num_col;
}




