#ifndef SOLUTION_H
#define SOLUTION_H
#include <vector>
#include "Input.h"
#include "Control.h"
#include "Random.h"

using namespace std;

class Coloring 
{
  friend std::ostream& operator<<(std::ostream&, const Coloring&);
 public:   
  Coloring(Random* rnd, Graph* pin);  
  Coloring() : p_in(0), rg(0) {};
  virtual ~Coloring() {};
  Coloring(const Coloring &);

  void SetInput(Graph* pin);
  void SetColors(Color num_col);
  const Color CurrColors() const {return k;};
  Coloring& operator=(const Coloring &a);
  bool operator==(const Coloring &a);

  ColorMap col;  // the map between nodes of the graphs and colors
  fvalue fitness;
 
  bool feasible;
  Color k; // the actual number of colors used 
protected:
  Graph *p_in; 
  Random* rg;
};

#endif
