#ifndef SOLUTIONMANAGER_H
#define SOLUTIONMANAGER_H
#include <vector>
#include "Input.h"
#include "Control.h"
#include "Random.h"
#include "Solution.h"

using namespace std;

class SolutionManager
{
 public:
  SolutionManager(Random *rnd, Graph* pin,Control *ctrl);
  virtual ~SolutionManager() {};
  virtual fvalue computeFitness(Coloring &ass);
  void updateColoringData(Coloring &ass) const; 
  void randomAssignment(Coloring&, Color num_col);
  
 protected:
  void SetInput(Graph* pin) { p_in = pin; }
  Graph *p_in;
  Random* rg;
  Control *p_ctrl;  
}; 



class Move
{
 public:
  friend std::ostream& operator<<(std::ostream&, const Move&);
  Move();
  Move(const Move &a);
  Move& operator=(const Move &a);
  bool operator==(const Move &a);
  fvalue delta;
};



#endif
