#ifndef SOLVER_H
#define SOLVER_H
#include <vector>
#include "Input.h"
#include "Control.h"
#include "Random.h"
#include "Solution.h"
#include "SolutionManager.h"
#include "Explorer.h"
#include "Runners.h"


  /** The Simple Local Search solver handles a simple local search algorithm
      encapsulated in a runner.
  */

class Solver
  {
  public:
    Solver(Control *c):p_ctrl(c) {}
    virtual ~Solver() {};
    virtual void addRunner(Runner *r) {};
    virtual void Solve(Coloring &current) {}; 
  protected:
    
    Control* p_ctrl;    
 
  };


class ConstructionHeuristics:public Solver
{
  public:
  ConstructionHeuristics(Control* c):Solver(c) {};
  ConstructionHeuristics(Control* c,
		Runner* r):Solver(c), p_runner(r) {};
  virtual ~ConstructionHeuristics() {};
  void Solve(Coloring &current);
 protected:
  Runner* p_runner; /**< A pointer to the managed runner. */
};

#endif
